set termout on
set echo on
set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set trimspool on

spool testcase.log

-- built on my vpd plan testcase so I can see the query predicate
-- want to show example of masking a column for all users but certain ones
-- I think create users cansee and cannotsee with minimal privileges so they
-- do not have exempt access policy

select * from v$version;

drop user cansee cascade;
drop user cannotsee cascade;
drop user test cascade;

create user cansee identified by cansee;
create user cannotsee identified by cannotsee;
create user test identified by test;

grant dba to test;
grant create session to cansee,cannotsee;

create table test.table_list as 
select owner,table_name,blocks 
from dba_tables
where rownum < 11;

grant select on test.table_list to cansee,cannotsee;

CREATE OR REPLACE FUNCTION TEST.VPD_FUNCTION(d1 varchar2,d2 varchar2) return varchar2
is
predicate varchar2 (2000);
begin
  predicate := 'user<>''CANNOTSEE''';
  return predicate;
end;
/

begin

SYS.DBMS_RLS.ADD_POLICY     (
      object_schema          => 'TEST'
      ,object_name           => 'TABLE_LIST'
      ,policy_name           => 'VPD_TEST_POLICY'
      ,function_schema       => 'TEST'
      ,policy_function       => 'VPD_FUNCTION'
      ,sec_relevant_cols     => 'BLOCKS',
       sec_relevant_cols_opt => dbms_rls.ALL_ROWS);
END;
/

select * from test.table_list;
select * from table(dbms_xplan.display_cursor(null,null,'ALLSTATS'));

alter session set max_dump_file_size = unlimited;
ALTER SESSION SET tracefile_identifier = 'vpdexample';

ALTER SESSION SET EVENTS '10053 trace name context forever, level 1';

select /* comment to force parse */ * from test.table_list;

ALTER SESSION SET EVENTS '10053 trace name context OFF';

connect cansee/cansee@ORCL1124

select * from test.table_list;

connect cannotsee/cannotsee@ORCL1124

select * from test.table_list;

connect test/test@ORCL1124

GRANT EXEMPT ACCESS POLICY TO cannotsee;

connect cannotsee/cannotsee@ORCL1124

select * from test.table_list;

spool off

